
#pragma once

#include <cstdio>
#include <new>

class Protector
{
protected:
	FILE *m_file_out;

	unsigned char* m_buf;
	size_t         m_size;

public:
	Protector()
	{
		m_buf = NULL;
		m_file_out = NULL;
	}
	virtual ~Protector()
	{
		close();
		if ( m_buf )
			delete [] m_buf;
	}

	virtual void Protect() = 0;

	bool open( char *input_file_name, char *output_file_name )
	{
		FILE *fin, *fout;
		unsigned char *buf;
		size_t size, rsize;

		fin  = fopen( input_file_name,  "rb" );
		fout = fopen( output_file_name, "wb" );
		if ( !fin || !fout ) {
			goto ret_close;
		}

		fseek( fin, 0, SEEK_END );
		size = ftell( fin );
		fseek( fin, 0, SEEK_SET );

		try {
			buf = new unsigned char[size];
		} catch ( std::bad_alloc )
		{
			goto ret_close;
		}

		rsize = fread( buf, 1, size, fin );
		if ( !rsize ) {
			goto ret_close;
		}

		fclose( fin );

		m_file_out = fout;
		m_buf = buf;
		m_size = rsize;

		return true;

	ret_close:
		if ( fin )
			fclose( fin );
		if ( fout )
			fclose( fout );

		return false;
	}

	void write()
	{
		fwrite(m_buf, 1, m_size, m_file_out);
	}

	void close()
	{
		if ( m_file_out )
			fclose( m_file_out );
	}
};

