
#include <cstdio>
#include <cstdlib>
#include <memory>
#include <time.h>
#include "Protector.h"

#define SS_CRYPTER
#include "../signature.h"

class SimpleCrypter : public Protector
{
public:
	void Protect()
	{
		EncryptString();
	}

private:

	bool findsign(unsigned int begin, unsigned int &pos, const void *sign, const unsigned int size)
	{
		while ( begin < m_size ) {
			if ( memcmp(m_buf + begin, sign, size) == 0 ) {
				pos = begin;
				return true;
			}
			begin++;
		}
		return false;
	}

	void EncryptString()
	{
		unsigned int offset = 0, end_pos, pos;
		while ( findsign(offset, pos, sign_str, sizeof(sign_str)) ) {
			bool res = findsign( pos + sizeof(sign_str), end_pos, sign_end, sizeof(sign_end) );
			if ( !res ) {
				printf( "error: Not found END SIGNATURE\n" );
				return;
			}
			printf( "offset: %d  size: %d\n", pos + sizeof(sign_str), end_pos - sizeof(sign_str) - pos );
			doEncryptString( (char*)m_buf + pos, end_pos - sizeof(sign_str) - pos );
			offset = end_pos;
		}
	}

	void doEncryptString(char *buf, int size)
	{
		// sign_str Aړ
		memmove( buf, buf + sizeof(sign_str), size );
		// Í
		for ( int i = 0; i < size; i++ ) {
			buf[i] ^= STRING_CRYPT_X;
		}
		// sign_str_end Ԃ
		for ( int i = 0; i < sizeof(sign_str_end); i++ ) {
			buf[size+i] = rand() & 0xFF;
		}
		// sign_str_end
		memcpy( buf + size, sign_str_end, sizeof(sign_str_end) );
	}


};

#define FAILED(s) printf( s ? "OK\n" : "Failed!\n" ); if (!s) return 0;
#define VERSION "0.1"

void about()
{
	printf( "=== Simple String Crypter ver %s ===\n", VERSION );
}

void usage()
{
	printf( "usage: crypt <filename> <output>\n" );
}

int main(int argc, char *argv[])
{
	about();
	if ( argc != 3 ) {
		usage();
		return 0;
	}

	printf( "random initalized\n" );
	srand( time(0) );

	SimpleCrypter crypter;

	printf( "open: %s, %s\n", argv[1], argv[2] );
	FAILED( crypter.open(argv[1], argv[2]) );

	crypter.Protect();

	printf( "writting: %s\n", argv[2] );
	crypter.write();
	printf( "Finished!\n" );

	crypter.close();

	return 0;
}

